/* Tabela MOVCREDBANC: Movimento de Crdito Bancrio */
/* Descrio: A trigger insere registros na tabela LOGOPERA a partir de alteraes na tabela MOVCREDBANC */
/* Objetivo: Gerar um log que vai registrar as alteraes na tabela Movimento de Crdito Bancrio,
             utilizando a tabela Geral de Logs de Operaes */
CREATE OR REPLACE TRIGGER LOG_FIN_MOVCRED
AFTER DELETE OR INSERT OR UPDATE
ON MOVCREDBANC FOR EACH ROW
DECLARE
  V_USUARIO      VARCHAR2(40);
  V_TIPO         VARCHAR2(1);
  V_ITPESQ       VARCHAR2(40);
  V_DESC         VARCHAR2(300);
  V_CDFILLOGOPER VARCHAR2(4);
  V_DTOPER       DATE;
  V_DSREMOTEADDR VARCHAR2(15);
  V_DSREMOTEHOST VARCHAR2(15);
  V_DSSERVERRDM  VARCHAR2(20);
  V_DSSERVMETHOD VARCHAR2(30);
  V_DSREMOTEOPER VARCHAR2(12);
BEGIN
   V_CDFILLOGOPER := '';
   IF DELETING THEN
      V_TIPO   := '3';
      V_DESC   := 'Dt Cred. '   || TO_CHAR(:OLD.DTMOVICRED, 'DD/MM/YYYY') ||
                  ' Valor '     || TO_CHAR(:OLD.VRMOVICRED)               ||
                  ' Tipo Cred ' || :OLD.CDTPCREDBANC                      ||
                  ' ContCC '    || :OLD.CDREDUCONT                        ||
                  ' Empresa '   || :OLD.CDEMPRESA                         ||
                  ' Classf '    || :OLD.CDCLASSFINA                       ||
                  ' FiliFx '    || :OLD.CDFILIAL                          ||
                  ' DtFx'       || TO_CHAR(:OLD.DTMOVFLUXO, 'DD/MM/YYYY') ||
                  ' IdTpFx '    || :OLD.IDMOVFLUXO                        ||
                  ' NrMovBanc ' || :OLD.NRMOVBANC                         ||
                  ' FiliCred '  || :OLD.CDFILILANCRE;

      V_ITPESQ       := :OLD.CDREDUCONT||:OLD.NRMOVICRED|| '/' ||:OLD.NRMOVBANC;
      V_CDFILLOGOPER := :OLD.CDFILIAL;
   ELSE
      IF UPDATING THEN
         V_ITPESQ       := :OLD.CDREDUCONT||:OLD.NRMOVICRED|| '/' ||:OLD.NRMOVBANC;
         V_CDFILLOGOPER := :OLD.CDFILIAL;

         IF (:NEW.DTMOVICRED   <> :OLD.DTMOVICRED)    OR
            (:NEW.VRMOVICRED   <> :OLD.VRMOVICRED)    OR
            (:NEW.CDTPCREDBANC <> :OLD.CDTPCREDBANC)  OR
            (:NEW.CDREDUCONT   <> :OLD.CDREDUCONT)    OR
            (:NEW.CDFILILANCRE <> :OLD.CDFILILANCRE)  OR
            (:NEW.CDEMPRESA    <> :OLD.CDEMPRESA)     THEN
            V_TIPO   := '2';
         END IF;
      ELSE
         V_TIPO         := '1';
         V_ITPESQ       := :NEW.CDREDUCONT||:NEW.NRMOVICRED|| '/' ||:NEW.NRMOVBANC;
         V_CDFILLOGOPER := :NEW.CDFILIAL;
      END IF;

      V_DESC   := 'Dt Cred. '   || TO_CHAR(:NEW.DTMOVICRED, 'DD/MM/YYYY') ||
                  ' Valor '     || TO_CHAR(:NEW.VRMOVICRED)               ||
                  ' Tipo Cred ' || :NEW.CDTPCREDBANC                      ||
                  ' ContCC '    || :NEW.CDREDUCONT                        ||
                  ' Empresa '   || :NEW.CDEMPRESA                         ||
                  ' Classf '    || :NEW.CDCLASSFINA                       ||
                  ' FiliFx '    || :NEW.CDFILIAL                          ||
                  ' DtFx'       || TO_CHAR(:NEW.DTMOVFLUXO, 'DD/MM/YYYY') ||
                  ' IdTpFx '    || :NEW.IDMOVFLUXO                        ||
                  ' NrMovBanc ' || :NEW.NRMOVBANC                         ||
                  ' FiliCred '  || :NEW.CDFILILANCRE;
   END IF;

   IF V_TIPO <> '0' THEN
      NMUSUARIO(V_USUARIO);
      WEBTUNNING(V_DSREMOTEADDR,
                 V_DSREMOTEHOST,
                 V_DSSERVERRDM,
                 V_DSSERVMETHOD,
                 V_DSREMOTEOPER);
      IF NOT V_DESC IS NULL THEN
         IF NOT V_USUARIO IS NULL THEN
            V_DTOPER := SYSDATE;

            INSERT INTO LOGOPERA
               (NMTABELA,   DTOPERACAO, NMRESPOPER,
                IDTIPOOPER, CDPESQITEM, DSOPERACAO, CDFILLOGOPER,
                DSRDMUSUOPER, DSENDUSUOPER, DSNMUSUOPER, DSMETUSUOPER, CDORESPOPER)
            VALUES
               ('MOVCREDBANC', V_DTOPER, V_USUARIO,
                V_TIPO,         V_ITPESQ, V_DESC, V_CDFILLOGOPER,
                V_DSSERVERRDM, V_DSREMOTEADDR, V_DSREMOTEHOST, V_DSSERVMETHOD, V_DSREMOTEOPER);
         END IF;
      END IF;
   END IF;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('LOG_FIN_MOVCRED','5.20.000'); END;
/
