/******************************************************************************/
/* Sistemas Integrados TECNISA                                                */
/* Nome: DENADAI_DTULTATU_CLIENTE.sql                                         */
/*                                                                            */
/* Criao:                                                                   */
/* 08/07/2009 - Leonardo Bispo                                                */
/******************************************************************************/

DROP TRIGGER DTULTATU_CLIENTE
/

CREATE OR REPLACE TRIGGER DENADAI_DTULTATU_CLIENTE
BEFORE INSERT OR UPDATE OR DELETE
ON CLIENTE FOR EACH ROW

BEGIN
   IF INSERTING THEN
      :NEW.DTULTATUCLIE := SYSDATE;
   END IF;
   IF UPDATING THEN
      IF (NVL(:OLD.CDCLIENTE,0)    <> NVL(:NEW.CDCLIENTE,0))    OR
         (NVL(:OLD.NMFANTCLIE,0)   <> NVL(:NEW.NMFANTCLIE,0))   OR
         (NVL(:OLD.NMRAZSOCCLIE,0) <> NVL(:NEW.NMRAZSOCCLIE,0)) OR
         (NVL(:OLD.IDTPIJURCLIE,0) <> NVL(:NEW.IDTPIJURCLIE,0)) OR
         (NVL(:OLD.NRINSJURCLIE,0) <> NVL(:NEW.NRINSJURCLIE,0)) OR
         (NVL(:OLD.NRINSESTCLIE,0) <> NVL(:NEW.NRINSESTCLIE,0)) OR
         (NVL(:OLD.CDSEGMER,0)     <> NVL(:NEW.CDSEGMER,0))     OR
         (NVL(:OLD.VRPEMULBCLI,0)  <> NVL(:NEW.VRPEMULBCLI,0))  OR
         (NVL(:OLD.VRPEMORBCLI,0)  <> NVL(:NEW.VRPEMORBCLI,0))  OR
         (NVL(:OLD.CDEXCLIENTE,0)  <> NVL(:NEW.CDEXCLIENTE,0))  OR
         (NVL(:OLD.CDIDCLIENTE,0)  <> NVL(:NEW.CDIDCLIENTE,0))  OR
         (NVL(:OLD.CDGRUPOFISC,0)  <> NVL(:NEW.CDGRUPOFISC,0))  OR
         (NVL(:OLD.CDMODDOCFISC,0) <> NVL(:NEW.CDMODDOCFISC,0)) OR
         (NVL(:OLD.DTVALQUALIC,TO_DATE('31/12/1899','DD/MM/YYYY')) <>
          NVL(:NEW.DTVALQUALIC,TO_DATE('31/12/1899','DD/MM/YYYY'))) OR
         (NVL(:OLD.IDTPFORPGTCL,0) <> NVL(:NEW.IDTPFORPGTCL,0)) OR
         (NVL(:OLD.IDFORMPGCLIE,0) <> NVL(:NEW.IDFORMPGCLIE,0)) OR
         (NVL(:OLD.IDUTLICEUSO,0)  <> NVL(:NEW.IDUTLICEUSO,0))  OR
         (NVL(:OLD.CDFORMPGTO,0)   <> NVL(:NEW.CDFORMPGTO,0))   OR
         (NVL(:OLD.NRPARCPGTOCL,0) <> NVL(:NEW.NRPARCPGTOCL,0)) OR
         (NVL(:OLD.NRDIAPGFIXCL,0) <> NVL(:NEW.NRDIAPGFIXCL,0)) OR
         (NVL(:OLD.IDUTDIAPGTCL,0) <> NVL(:NEW.IDUTDIAPGTCL,0)) OR
         (NVL(:OLD.CDFILTABPREC,0) <> NVL(:NEW.CDFILTABPREC,0)) OR
         (NVL(:OLD.CDFILTABPREC,0) <> NVL(:NEW.CDFILTABPREC,0)) OR
         (NVL(:OLD.IDZERSALDCON,0) <> NVL(:NEW.IDZERSALDCON,0)) OR
         (NVL(:OLD.IDVERSALDCLI,0) <> NVL(:NEW.IDVERSALDCLI,0)) OR
         (NVL(:OLD.CDTABEPREC,0)   <> NVL(:NEW.CDTABEPREC,0)) OR
         (NVL(:OLD.VRPEMAXDESCL,0) <> NVL(:NEW.VRPEMAXDESCL,0)) OR
         (NVL(:OLD.VRPEMAXDESCL,0) <> NVL(:NEW.VRPEMAXDESCL,0)) OR
         (NVL(:OLD.CDMODPGTO,0) <> NVL(:NEW.CDMODPGTO,0)) OR
         (NVL(:OLD.IDENDEMISCLI ,0) <> NVL(:NEW.IDENDEMISCLI ,0)) OR
         (NVL(:OLD.IDCLIEATIV,0) <> NVL(:NEW.IDCLIEATIV,0)) OR
         (NVL(:OLD.CDVENDEDOR,0) <> NVL(:NEW.CDVENDEDOR,0)) OR
         (NVL(:OLD.IDCALCDVCLIE ,0) <> NVL(:NEW.IDCALCDVCLIE ,0)) OR
         (NVL(:OLD.CDATIVCLI,0) <> NVL(:NEW.CDATIVCLI,0)) OR
         (NVL(:OLD.CDTPCTRECEB,0) <> NVL(:NEW.CDTPCTRECEB,0)) OR
         (NVL(:OLD.NMCOMPRZSCLI, 0) <> NVL(:NEW.NMCOMPRZSCLI, 0)) OR
         (NVL(:OLD.CDGRUPCLIE,   0) <> NVL(:NEW.CDGRUPCLIE,   0)) THEN
         :NEW.DTULTATUCLIE := SYSDATE;
      END IF;
   END IF;
   IF DELETING THEN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
                       VALUES ('CLIENTE', '', 'CDCLIENTE='||:OLD.CDCLIENTE||';', SYSDATE);
   END IF;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('DENADAI_DTULTATU_CLIENTE','5.09.000'); END;
/
